# Copyright (c) 2003-2016 Eelco Dolstra and the Nixpkgs/NixOS contributors
# SPDX-FileCopyrightText: 2024 Clicks Codes
#
# SPDX-License-Identifier: MIT

{
  lib,
  ...
}: {
  types.modules = {
    taggedSubmodule =
      { types
      , specialArgs ? {}
      }: lib.types.mkOptionType rec {
      name = "taggedSubmodule";
      description = "submodules tagged by ._type";
      check = x: if x ? _type then types.${x._type}.check x else throw "No ._type option set in:\n${lib.generators.toPretty {} x}";
      merge = loc: lib.lists.foldl'
        (res: def: types.${def.value._type}.merge loc [
          (lib.attrsets.recursiveUpdate { value._module.args = specialArgs; } def)
        ])
        { };
      nestedTypes = types;
    };
  };
}
